<template>
  <div
    v-if="!announcement.IsHidden"
    class="announcement py-2 bg-background1 h-[32px] pl-4 overflow-hidden"
  >
    <div class="container flex items-center h-full mx-auto">
      <utils-announcement :announcement="announcement.Text" />
    </div>
  </div>
  <!-- TODO: Implement for BK8 Header when this also intergrated for BK8 Theme -->
  <div ref="bannerRef" class="w-full">
    <BannerMobileRender actived-tab="home" :banner-keys="bannerKeys" />
  </div>
  <div
    class="concrete-bg fixed w-full h-full ol-bg-light-2 l-1350 left-0"
  ></div>
  <div class="py-2 flex flex-col gap-2 mt-2 relative z-1">
    <MobileConcreteTabType />
    <div
      class="w-full h-0.5 bg-[#D9D9D9]"
      style="border: 1px solid var(--border)"
    ></div>
    <SharedConcreteCardEntry />
  </div>
</template>

<script setup lang="ts">
import { useElementSize } from "@vueuse/core";
import { IThemePropertiesFromApi } from "~~/models/companyThemePropertiesRespone";
import { store } from "~~/store";

const bannerRef = ref();

const { height } = useElementSize(bannerRef);

const themeProperties = computed(
  () => store.state.companyThemePropertiesFromApi.ThemeProperties
);

const announcement = computed(
  (): IThemePropertiesFromApi =>
    themePropertyHelper.getSingleThemeProperty(
      themeProperties.value,
      "announcement"
    )
);

const setProperty = (key: string, value: string | number) => {
  document.documentElement.style.setProperty(key, `${value}`);
};

watch(
  height,
  () => {
    setProperty("--mobile-banner-height", `${height.value}px`);
  },
  {
    immediate: true,
    deep: true,
  }
);

watch(
  () => announcement.value.IsHidden,
  (IsHidden) => {
    if (!IsHidden) {
      setProperty("--mobile-announcement-height", "32px");
    }
  },
  {
    immediate: true,
  }
);

const bannerKeys: Record<string, string> = {
  home: "lobby_banner_",
  sports: "sport_banner_",
  virtualsports: "virtual_sport_banner_",
  livecasino: "live_casino_banner_",
  games: "game_banner_",
  poker: "poker_banner_",
  lottery: "lottery_banner_",
  cockfight: "cockfight_banner_",
  promotion: "promotion_banner_",
};
</script>

<style lang="scss">
.concrete-bg {
  --bg-base-color: var(--background5);
  --bg-opacity: 0.35;
  z-index: 0;

  top: calc(
    var(--mobile-header-height, 0) + var(--mobile-announcement-height, 0) +
      var(--mobile-banner-height, 0) + 8px
  );
}
</style>
